#include <cstdio>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

const int maxn = 1 << 17;

int n;
int x[maxn], y[maxn];
int L[maxn], R[maxn];
double dp[maxn];

double d(int i, int j) {
 	return sqrt(1.0 * (x[i] - x[j]) * (x[i] - x[j]) + 1.0 * (y[i] - y[j]) * (y[i] - y[j]));
}

void findLR() {
	for (int i = 0; i < n; i++) L[i] = R[i] = -1;
	
	vector<int> v;
	for (int i = 0; i < n; i++) {
	 	while (!v.empty() && y[v.back()] < y[i]) {
	 	 	R[v.back()] = i;
			v.pop_back();
		}
		if (!v.empty()) L[i] = v.back();
		if (!v.empty()) {
			L[i] = v.back();
			if (y[i] == y[v.back()]) {
	    	 	R[v.back()] = i;
				v.pop_back();
			}
		}
		v.push_back(i);
	}
}

int main() {
 	freopen("icebergs.in", "r", stdin);
	freopen("icebergs.out", "w", stdout);

	cin >> n;
	for (int i = 0; i < n; i++) {
	 	cin >> x[i] >> y[i];
	}
	findLR();

	dp[0] = 0;
	for (int i = 1; i < n; i++) dp[i] = 1e20;

	for (int i = 0; i < n; i++) {
		if (L[i] != -1) dp[i] = min(dp[i], max(dp[L[i]], d(i, L[i])));
		if (R[i] != -1) dp[R[i]] = min(dp[R[i]], max(dp[i], d(i, R[i])));
	}

	cout.precision(10);
	cout << fixed;
	cout << dp[n - 1] << endl;

	return 0;
}